#!/bin/bash
#this script is useful to execute the program from the IPOL demo
workdir=$1
bindir=$2
tmpdir=${1}tmp
method=$3
sigma=$4

video_in=${workdir}input_0.mp4

if [ "$5" -eq "1" ] ; then
  dithering="-d"
fi

#create temporal directory
mkdir $tmpdir

#extract info from video
width=$(avprobe -v error -show_streams  $video_in| grep width | cut -d'=' -f 2)
height=$(avprobe -v error -show_streams  $video_in| grep height | cut -d'=' -f 2)
framerate=$(avprobe -v error -show_streams  $video_in| grep avg_frame_rate | cut -d'=' -f 2)
nframes=$(avprobe -v error -show_streams  $video_in| grep nb_frames | cut -d'=' -f 2)
size=${width}x${height}

#show input information
echo 0.-Input parameters and video info
echo " "Smoothing sigma: $sigma
echo " "Dithering: $dithering Method: $method
echo " "Widht: $width, Height: $height, Number of frames: $nframes, Frame rate: $framerate
echo

#convert input video to raw data rgb 3 bytes
echo 1.-Convert input video to raw data 
time avconv -v error -i ${workdir}input_0.mp4 -f rawvideo -pix_fmt rgb24 -y $tmpdir/video.raw
echo

#execute main program
echo 2.-Midway video equalization 
time $bindir/midway_video $tmpdir/video.raw $width $height $nframes -o $tmpdir/outvideo.raw -m $method -s $sigma $dithering -v 
echo

#generate histogram videos
echo 3.-Generate histogram videos for IPOL demo
time $bindir/generate_output $tmpdir/video.raw $tmpdir/outvideo.raw $tmpdir/ $width $height $nframes 
echo

#create output video
echo 4.-Convert output video to mp4
time avconv -v error -f rawvideo -pix_fmt rgb24 -video_size $size -framerate $framerate -i $tmpdir/outvideo.raw  -pix_fmt yuv420p -y ${workdir}/output.mp4
echo

#create histograms videos
echo 5.-Convert histogram videos to mp4
time avconv -v error -f rawvideo -pix_fmt rgb24 -video_size 258x202 -framerate $framerate -i $tmpdir/histogram1.raw  -pix_fmt yuv420p -y ${workdir}acc_histogram1.mp4
time avconv -v error -f rawvideo -pix_fmt rgb24 -video_size 258x202 -framerate $framerate -i $tmpdir/lhistogram1.raw  -pix_fmt yuv420p -y ${workdir}histogram1.mp4
time avconv -v error -f rawvideo -pix_fmt rgb24 -video_size 258x202 -framerate $framerate -i $tmpdir/histogram2.raw  -pix_fmt yuv420p -y ${workdir}acc_histogram2.mp4
time avconv -v error -f rawvideo -pix_fmt rgb24 -video_size 258x202 -framerate $framerate -i $tmpdir/lhistogram2.raw  -pix_fmt yuv420p -y ${workdir}histogram2.mp4

#remove temporal data
rm -R $tmpdir
