#ifndef HISTOGRAM_H
#define HISTOGRAM_H

#define PIXEL_RANGE 256
#define BIN_SIZE 1024
#define BIN_RATE BIN_SIZE/PIXEL_RANGE
#define INV_BIN_RATE PIXEL_RANGE/BIN_SIZE


void channel_histogram(
  unsigned char *I, //input image
  float *histogram, //output histogram
  int    nx,        //number of columns
  int    ny,        //number of rows
  int    nz         //number of channels
);


void compute_channel_normalized_histogram(
  unsigned char *I, //input image
  float *histogram, //output histogram
  int    nx,        //number of columns
  int    ny,        //number of rows
  int    nz         //number of channels
);


void compute_normalized_histogram(
  float *I,         //input image
  float *histogram, //output histogram
  int    nx,        //number of columns
  int    ny         //number of rows
);

#endif
